/**
 *	\file		server.h
 *	\author		Tranchida Giulio, No Matricola 241732\n
 *				Si dichiara che il contenuto di questo file e',
 * 				in ogni sua parte, opera originale dell'autore.\n\n
 *
 * This program is free software; you can redistribuite it and/or modify
 * it under the terms of the GNU/General Pubblic License as published the
 * Free software Foundation; either version 2 of the License, or
 * (at your opinion) any later version.
 * */
#ifndef SERVER_H_
#define SERVER_H_

#include <fcntl.h>
#include <sys/stat.h>

#include "common.h"
#include "comandi.h"
#include "lista.h"
#include "../../../Fat/Src/Include/fat.h"
#include "../../../Fat/Src/Include/load_fat.h"

/** Flag di uscita:
 * - settata ad 0 nel main in fase di avvio del programma
 * - settata ad 1 nel gestore dei segnali */
volatile sig_atomic_t quitflag;

/**
 * Il mio gestore dei segnali\n
 * Stampa a monitor il codice del segnale ricevuto se questo
 * e' SIGTERM o SIGINT e mette quitflag a 1, altrimenti se e'
 * un SIGPIPE non fa nulla.
 * 
 * \param sig codice del segnale ricevuto 
 * */
void gestore(int sig);

struct lista my_socket; /**< La mia lista dei socket */
serverChannel_t sk_ascolto; /**< tipo descrittore canale di ascolto (server) */
struct fat_ctrl f_ctrl;	 /**< struttura per il mounting del filesystem */

/** Puntatore per il filesystem */
FILE * fs;

/** Mutex per il filesystem */
pthread_mutex_t filesystem = PTHREAD_MUTEX_INITIALIZER;

/** Mutex per la variabile 'num_threads' */
pthread_mutex_t lock = PTHREAD_MUTEX_INITIALIZER;

/** Variabile condizione per l'attesa sul mutex 'lock' */
pthread_cond_t wait_me = PTHREAD_COND_INITIALIZER;

int num_threads;		/**< Conteggia il numero dei threads */

#endif /*SERVER_H_*/
