/**
 *	\file		load_fat.c
 *	\author		Tranchida Giulio, No Matricola 241732\n
 *				Si dichiara che il contenuto di questo file e',
 * 				in ogni sua parte, opera originale dell'autore.\n\n
 *
 * This program is free software; you can redistribuite it and/or modify
 * it under the terms of the GNU/General Pubblic License as published the
 * Free software Foundation; either version 2 of the License, or
 * (at your opinion) any later version.
 * */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include "Include/fat.h"
#include "Include/load_fat.h"
#include "Include/sfaterror.h" 

int mount_fat(FILE *fs, struct fat_ctrl *f_ctrl){
	
	if ( !(fs) || !(f_ctrl) ) return EBDP;
	/* Lettura informazioni del boot sector */
	if (!(fread(&(f_ctrl->b_sector), sizeof(struct boot_sector), 1, fs))){;
    	sfaterror(ERFCD);
    	return ERFCD;
	}

	/* Alloco memoria per la FAT */
	if (!(f_ctrl->fat_ptr = calloc((f_ctrl->b_sector).num_block, sizeof(unsigned int)))){
    	sfaterror(STDLIBERR);
    	return STDLIBERR;
	} 
	
	/* Lettura dei dati della FAT */
	if (!(fread(f_ctrl->fat_ptr,((f_ctrl->b_sector).num_block * sizeof(unsigned int)), 1, fs))){
    	sfaterror(ERFCD);
    	return ERFCD;
	}
	
	f_ctrl->blk_base = sizeof(struct boot_sector) + (sizeof(unsigned int) * (f_ctrl->b_sector).num_block); 
	
	return 0;
}
