/**
 *	\file		sfaterror.c
 *	\author		Tranchida Giulio, No Matricola 241732\n
 *				Si dichiara che il contenuto di questo file e',
 * 				in ogni sua parte, opera originale dell'autore.\n\n
 *
 * This program is free software; you can redistribuite it and/or modify
 * it under the terms of the GNU/General Pubblic License as published the
 * Free software Foundation; either version 2 of the License, or
 * (at your opinion) any later version.
 * */
 
 #include <stdio.h>
 #include <errno.h>
 
 #include "Include/sfaterror.h"
 #include "Include/fat_defs.h"
 
 void sfaterror(int err){
 	int err_no;
 	
 	err_no = errno;
 	switch(err){
		case STDLIBERR:
			perror(NULL);
			fprintf(stderr,"Error No: %d\n",err_no);
			errno = err_no;
		break;
		case ENTL:
			fprintf(stderr,"Error Name Too Long (exceeding MAX_LEN_NAME)\n");
		break;
		case ERFCD:
			fprintf(stderr,"Error Reading Fat Control Data \n");
		break;
		case ERBD:
			fprintf(stderr,"Error Reading Block Data \n");
		break;
		case ENSFD:
			fprintf(stderr,"Error No Such File or Directory \n");
		break;
		case EDAEX:
			fprintf(stderr,"Error File/Directory Already Exists \n");
		break;
		case ENMSD:
			fprintf(stderr,"Error No More Space on Device \n");
		break;
		case EWFCD:
			fprintf(stderr,"Error Writing Fat Control Data \n");
		break;
		case EWBD:
			fprintf(stderr,"Error Writing Block Data \n");
		break;
		case EBDP:
			/* fprintf(stderr,"Error Bad Directory Path \n"); */
		break;
 	}
}
